const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const inventory_items = sequelize.define(
    'inventory_items',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

quantity_on_hand: {
        type: DataTypes.INTEGER,
      
      

      },

quantity_reserved: {
        type: DataTypes.INTEGER,
      
      

      },

quantity_available: {
        type: DataTypes.INTEGER,
      
      

      },

average_cost: {
        type: DataTypes.DECIMAL,
      
      

      },

as_of_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  inventory_items.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity





























//end loop



    db.inventory_items.belongsTo(db.organizations, {
      as: 'organization',
      foreignKey: {
        name: 'organizationId',
      },
      constraints: false,
    });

    db.inventory_items.belongsTo(db.products, {
      as: 'product',
      foreignKey: {
        name: 'productId',
      },
      constraints: false,
    });

    db.inventory_items.belongsTo(db.warehouses, {
      as: 'warehouse',
      foreignKey: {
        name: 'warehouseId',
      },
      constraints: false,
    });




    db.inventory_items.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.inventory_items.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return inventory_items;
};


